Loading...
Searching...
No Matches
Opm::WDFAC Class Reference

## Classes

struct | Correlation
| Parameters for Dake's D-factor correlation model. More...

## Public Member Functions

| WDFAC ()=default
| Default constructor.
| WDFAC (const RestartIO::RstWell &rst_well)
| Constructor.
void | updateWDFAC (const DeckRecord &record)
| Configure D-factor calculation from well-level D-factor description (keyword 'WDFAC').
void | updateWDFACCOR (const DeckRecord &record)
| Configure D-factor calculation from Dake correlation model (keyword WDFACCOR).
void | updateWDFACType (const WellConnections &connections)
| Check if any input-level connctions have a non-trivial D-factor and update this well's D-factor category accordingly.
void | updateTotalCF (const WellConnections &connections)
| Capture sum of all CTFs for the purpose of translating well-level D-factors to connection-level D-factors.
template<typename DensityCallback, typename GasViscCallback>
double | getDFactor (DensityCallback &&rhoGS, GasViscCallback &&gas_visc, const Connection &conn) const
| Retrieve currently configured D-factor for single connection.
const Correlation & | getDFactorCorrelationCoefficients () const
| Retrieve current D-factor correlation model coefficients.
bool | useDFactor () const
| Whether or not a flow-dependent skin factor ('D') has been configured for the current well.
bool | operator== (const WDFAC &other) const
| Equality operator.
bool | operator!= (const WDFAC &other) const
| Inequality operator.
template<class Serializer>
void | serializeOp (Serializer &serializer)
| Serialisation operator.

## Static Public Member Functions

static WDFAC | serializationTestObject ()
| Serialisation test object.

## Constructor & Destructor Documentation

## WDFAC()

Opm::WDFAC::WDFAC | ( | const RestartIO::RstWell & | rst_well | ) |

explicit

Constructor.

Creates an object from restart information

Parameters

  [in] | rst_well | Linearised well-level restart information, including D-factor parameters.

## Member Function Documentation

## getDFactor()

template<typename DensityCallback, typename GasViscCallback>

double Opm::WDFAC::getDFactor | ( | DensityCallback && | rhoGS,
|  | GasViscCallback && | gas_visc,
|  | const Connection & | conn ) const

inline

Retrieve currently configured D-factor for single connection.

Template Parameters

  DensityCallback | Callback type for evaluating the gas component mass density at surface conditions. Expected to provide a function call operator taking no arguments and returning a single scalar convertible to `double`.
  GasViscCallback | Callback type for evaluating the gas phase viscosity at reservoir conditions. Expected to provide a function call operator taking no arguments and returning a single scalar convertible to `double`.

Parameters

  [in] | rhoGS | Callback function for evaluating the gas component mass density at surface conditions. Invoked only if the D-factor is configured to use the Dake model correlation.
  [in] | gas_visc | Callback function for evaluating the gas phase viscosity at reservoir conditions. Invoked only if the D-factor is configured to use the Dake model correlation.
  [in] | conn | Reservoir connection for which to retrieve the D-factor.

Returns
  D-factor for connection `conn`.

## operator!=()

bool Opm::WDFAC::operator!= | ( | const WDFAC & | other | ) | const

inline

Inequality operator.

Parameters

  [in] | other | Object to which `*this` will be compared.

## operator==()

bool Opm::WDFAC::operator== | ( | const WDFAC & | other | ) | const

Equality operator.

Parameters

  [in] | other | Object to which `*this` will be compared.

## serializeOp()

template<class Serializer>

void Opm::WDFAC::serializeOp | ( | Serializer & | serializer | ) |

inline

Serialisation operator.

Template Parameters

  Serializer | Protocol for serialising and deserialising objects between memory and character buffers.

Parameters

  [in,out] | serializer | Serialisation object.

## updateTotalCF()

void Opm::WDFAC::updateTotalCF | ( | const WellConnections & | connections | ) |

Capture sum of all CTFs for the purpose of translating well-level D-factors to connection-level D-factors.

Parameters

  [in] | connections | Connection set as defined by keyword COMPDAT.

## updateWDFAC()

void Opm::WDFAC::updateWDFAC | ( | const DeckRecord & | record | ) |

Configure D-factor calculation from well-level D-factor description (keyword 'WDFAC').

Parameters

  [in] | record | Well-level D-factor description. Single record from WDFAC keyword.

## updateWDFACCOR()

void Opm::WDFAC::updateWDFACCOR | ( | const DeckRecord & | record | ) |

Configure D-factor calculation from Dake correlation model (keyword WDFACCOR).

Parameters

  [in] | record | Dake correlation model description. Single record from WDFACCOR keyword.

## updateWDFACType()

void Opm::WDFAC::updateWDFACType | ( | const WellConnections & | connections | ) |

Check if any input-level connctions have a non-trivial D-factor and update this well's D-factor category accordingly.

Parameters

  [in] | connections | Connection set as defined by keyword COMPDAT. This function will detect if any of the connections created from COMPDAT define a non-trivial D-factor at the connection level (item 12 of COMPDAT) and update the D-factor category if so.

The documentation for this class was generated from the following files:

- opm/input/eclipse/Schedule/Well/WDFAC.hpp
- opm/input/eclipse/Schedule/Well/WDFAC.cpp